cmd='melt'
#vfile='forrest_gump_h264_rf20_992x422_noaudio.m4v'
vfile='fixation_screen.png'
afile='forrest_gump_ad_ger_stereo.flac'
#afile='forrest_gump_eng_stereo.flac'

fps = 25
tr = 2.0
leadvolumes = 3
trailvolumes = 5
fadeoutframes = 100
fadeinframes = 25
vtrack_specs=''
atrack_specs='-attach-track ladspa.1197 0=-70 1=-40 -attach-track volume gain=10dB -attach-track ladspa.1403 0=-30 1=0.25 2=0.5 3=0.8 -attach-track ladspa.1913 0=20 1=-3 2=0.5'
# 0: peak limit dB, 1: release time (s), 2: fast compr. ratio, 3: compr.ratio
#atrack_specs='-attach-track ladspa.1403 1=0.1 2=0.0 3=0.0 wetness=0.1'

consumer = 'avformat:fg_ad_seg%i.mkv f=matroska s=940x400 aspect=2.35 acodec=libmp3lame ab=256k vcodec=libx264 b=500k'
#consumer = 'avformat:fg_av_seg%i.mkv f=matroska acodec=libmp3lame ab=256k vcodec=libx264 b=5000k'

# in-frame, out-frame
in_segments = (
    (0, 32312),
    (36349, 57798),
    (58470, 85997),
    (89293, 117351),
    (120616, 141457),
    (145869, 152269),
    (154244, 194792)
)

# cut at frame
# roughly 15min segments, after considering
# in_segments only, scene cuts
out_cuts = (
    22320,
    48014,
    70175,
    97461,
    123462,
    149402,
    178109,
    194803
)

last_tr_cut = 0
for oc_count, oc in enumerate(out_cuts):
    first = True
    snippet_length = 0
    #print 'WANT', oc
    # we want to start at a multiple of TR of where we ended
    new_tr_in = max(0, last_tr_cut - (leadvolumes * tr * fps))
    vtrack = 'gray_screen.png out=%i' % fadeinframes
    atrack = 'silence_1s.flac'
    for i, o in in_segments:
        #print 'HAVELENGTH', snippet_length
        #print 'IO', i, o,
        if o < new_tr_in:
            # this segment too early
            #print '-> SKIP'
            continue
        # where would we end the snippet if this was the last segment
        cand_endpoint = snippet_length + (oc - i)
        # next tr-compatible cut point relative to current snipped end
        cand_next_tr_prior_oc = cand_endpoint - (cand_endpoint % (fps * tr)) - snippet_length
        cand_new_tr_cut = cand_next_tr_prior_oc + (trailvolumes * tr * fps)
        if cand_new_tr_cut <= 0:
            # this segment too late
            #print '-> EXIT'
            #print 'DBG', cand_endpoint, cand_next_tr_prior_oc, cand_new_tr_cut
            break
        if i < new_tr_in:
            i = new_tr_in
        # turn relative end into abs again
        cand_next_tr_prior_oc += i
        cand_new_tr_cut += i
        if o > cand_new_tr_cut:
            o = cand_new_tr_cut
            # we found the actual cut point
            next_tr_prior_oc = cand_next_tr_prior_oc
        print '-> ACTUAL', i, o
        snippet_length += o - i
        fix_first = first
        if vfile.startswith('fixation'):
            # MAX 15000 frames
            nchunks = len(range(int((o-i)//14000)))
            print nchunks
            for l in range(nchunks):
                vtrack += ' %s out=14000' % vfile
                if fix_first:
                    vtrack += ' -mix %i -mixer luma' % fadeinframes
                    fix_first = False
            if nchunks and fix_first:
                vtrack += ' -mix %i -mixer luma' % fadeinframes
            vtrack += ' %s out=%i' % (vfile, int((o-i)%14000))
        else:
            vtrack += ' %s in=%i out=%i' % (vfile, i, o)
        atrack += ' %s in=%i out=%i' % (afile, i, o)
        if first:
            if fix_first:
                vtrack += ' -mix %i -mixer luma' % fadeinframes
            atrack += ' -mix %i -mixer mix:-1' % fadeinframes
            first = False
    print '#TRs:', float(snippet_length) / fps / tr
    print '#Duration:', float(snippet_length)/fps
    print '%s -video-track %s %s gray_screen.png out=%i -mix %i -mixer luma -audio-track %s %s silence_5s.flac -mix %i -mixer mix:-1 -consumer %s\n\n' \
            % (cmd, vtrack_specs, vtrack, fadeoutframes,
                    trailvolumes * tr * fps,
                    atrack_specs, atrack,
                    fadeoutframes,
                    consumer % oc_count)
    # this is the point where we stopped recording
    last_tr_cut = next_tr_prior_oc
